'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var core = require('@rest-hooks/core');
var React = require('react');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _construct(Parent, args, Class) {
  if (_isNativeReflectConstruct()) {
    _construct = Reflect.construct;
  } else {
    _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) _setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }

  return _construct.apply(null, arguments);
}

function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? new Map() : undefined;

  _wrapNativeSuper = function _wrapNativeSuper(Class) {
    if (Class === null || !_isNativeFunction(Class)) return Class;

    if (typeof Class !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }

    if (typeof _cache !== "undefined") {
      if (_cache.has(Class)) return _cache.get(Class);

      _cache.set(Class, Wrapper);
    }

    function Wrapper() {
      return _construct(Class, arguments, _getPrototypeOf(this).constructor);
    }

    Wrapper.prototype = Object.create(Class.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class);
  };

  return _wrapNativeSuper(Class);
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

var NotImplementedError = /*#__PURE__*/function (_Error) {
  _inheritsLoose(NotImplementedError, _Error);

  function NotImplementedError() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Error.call.apply(_Error, [this].concat(args)) || this;
    _this.message = process.env.NODE_ENV === 'production' ? 'Not Implemented' : 'Not Implemented. You must provide an override for this method.';
    return _this;
  }

  return NotImplementedError;
}( /*#__PURE__*/_wrapNativeSuper(Error));

function paramsToString(searchParams) {
  var params = new URLSearchParams(searchParams);

  try {
    params.sort(); // eslint-disable-next-line no-empty
  } catch (_unused) {}

  return params.toString();
}

/** Represents an entity to be retrieved from a server.
 * Typically 1:1 with a url endpoint.
 *
 * This can be a useful organization for many REST-like API patterns.
 */

var SimpleResource = /*#__PURE__*/function (_FlatEntity) {
  _inheritsLoose(SimpleResource, _FlatEntity);

  function SimpleResource() {
    return _FlatEntity.apply(this, arguments) || this;
  }

  // typescript todo: require subclasses to implement

  /** Used as base of url construction */
  SimpleResource.toString = function toString() {
    return this.name + "::" + this.urlRoot;
  }
  /** Returns the globally unique identifier for this SimpleResource */
  ;

  /** Get the url for a SimpleResource
   *
   * Default implementation conforms to common REST patterns
   */
  SimpleResource.url = function url(urlParams) {
    if (Object.prototype.hasOwnProperty.call(urlParams, 'url') && urlParams.url && typeof urlParams.url === 'string') {
      return urlParams.url;
    }

    if (this.pk(urlParams) !== undefined) {
      if (this.urlRoot.endsWith('/')) {
        return "" + this.urlRoot + this.pk(urlParams);
      }

      return this.urlRoot + "/" + this.pk(urlParams);
    }

    return this.urlRoot;
  }
  /** Get the url for many SimpleResources
   *
   * Default implementation conforms to common REST patterns
   */
  ;

  SimpleResource.listUrl = function listUrl(searchParams) {
    if (searchParams === void 0) {
      searchParams = {};
    }

    if (Object.keys(searchParams).length) {
      return this.urlRoot + "?" + paramsToString(searchParams);
    }

    return this.urlRoot;
  }
  /** Perform network request and resolve with json body */
  ;

  SimpleResource.fetch = function fetch(method, url, body) {
    // typescript currently doesn't allow abstract static methods
    throw new NotImplementedError();
  }
  /** Perform network request and resolve with HTTP Response */
  ;

  SimpleResource.fetchResponse = function fetchResponse(method, url, body) {
    // typescript currently doesn't allow abstract static methods
    throw new NotImplementedError();
  }
  /** @deprecated */

  /** Get the request options for this SimpleResource  */
  ;

  SimpleResource.getFetchOptions = function getFetchOptions() {
    return;
  }
  /** Init options for fetch - run at fetch */
  ;

  SimpleResource.getFetchInit = function getFetchInit(init) {
    return init;
  }
  /** Get the request options for this SimpleResource  */
  ;

  SimpleResource.getEndpointExtra = function getEndpointExtra() {
    return this.getFetchOptions();
  } // TODO: memoize these so they can be referentially compared

  /** Shape to get a single entity */
  ;

  SimpleResource.detailShape = function detailShape() {
    var _this = this;

    var getFetchKey = function getFetchKey(params) {
      return 'GET ' + _this.url(params);
    };

    var options = this.getEndpointExtra();
    return {
      type: 'read',
      schema: this,
      options: options,
      getFetchKey: getFetchKey,
      fetch: function fetch(params) {
        return _this.fetch('get', _this.url(params));
      }
    };
  }
  /** Shape to get a list of entities */
  ;

  SimpleResource.listShape = function listShape() {
    var _this2 = this;

    var getFetchKey = function getFetchKey(params) {
      return 'GET ' + _this2.listUrl(params);
    };

    var options = this.getEndpointExtra();
    return {
      type: 'read',
      schema: [this],
      options: options,
      getFetchKey: getFetchKey,
      fetch: function fetch(params) {
        return _this2.fetch('get', _this2.listUrl(params));
      }
    };
  }
  /** Shape to create a new entity (post) */
  ;

  SimpleResource.createShape = function createShape() {
    var _this3 = this;

    var options = this.getEndpointExtra();
    return {
      type: 'mutate',
      schema: this,
      options: options,
      getFetchKey: function getFetchKey(params) {
        return 'POST ' + _this3.listUrl(params);
      },
      fetch: function fetch(params, body) {
        return _this3.fetch('post', _this3.listUrl(params), body);
      }
    };
  }
  /** Shape to update an existing entity (put) */
  ;

  SimpleResource.updateShape = function updateShape() {
    var _this4 = this;

    var options = this.getEndpointExtra();
    return {
      type: 'mutate',
      schema: this,
      options: options,
      getFetchKey: function getFetchKey(params) {
        return 'PUT ' + _this4.url(params);
      },
      fetch: function fetch(params, body) {
        return _this4.fetch('put', _this4.url(params), body);
      }
    };
  }
  /** Shape to update a subset of fields of an existing entity (patch) */
  ;

  SimpleResource.partialUpdateShape = function partialUpdateShape() {
    var _this5 = this;

    var options = this.getEndpointExtra();
    return {
      type: 'mutate',
      schema: this,
      options: options,
      getFetchKey: function getFetchKey(params) {
        return 'PATCH ' + _this5.url(params);
      },
      fetch: function fetch(params, body) {
        return _this5.fetch('patch', _this5.url(params), body);
      }
    };
  }
  /** Shape to delete an entity (delete) */
  ;

  SimpleResource.deleteShape = function deleteShape() {
    var _this6 = this;

    var options = this.getEndpointExtra();
    return {
      type: 'mutate',
      schema: new core.schema.Delete(this),
      options: options,
      getFetchKey: function getFetchKey(params) {
        return 'DELETE ' + _this6.url(params);
      },
      fetch: function fetch(params) {
        return _this6.fetch('delete', _this6.url(params)).then(function () {
          return params;
        });
      }
    };
  };

  _createClass(SimpleResource, null, [{
    key: "key",
    get: function get() {
      return this.urlRoot;
    }
    /** Warning level for probable malformed responses
     *
     * We only 'warn' here since this is the upgrade path
     */

  }]);

  return SimpleResource;
}(core.FlatEntity); // We're only allowing this to get set for descendants but
// by default we want Typescript to treat it as readonly.


SimpleResource.urlRoot = void 0;
SimpleResource.automaticValidation = 'warn';
Object.defineProperty(SimpleResource.prototype, 'url', {
  get: function get() {
    if (this.__url !== undefined) return this.__url; // typescript thinks constructor is just a function

    var Static = this.constructor;
    return Static.url(this);
  },
  set: function set(url) {
    this.__url = url;
  }
});

var NetworkError = /*#__PURE__*/function (_Error) {
  _inheritsLoose(NetworkError, _Error);

  function NetworkError(response) {
    var _this;

    _this = _Error.call(this, response.statusText) || this;
    _this.status = response.status;
    _this.response = response;
    return _this;
  }

  return NetworkError;
}( /*#__PURE__*/_wrapNativeSuper(Error));
/**
 * Represents an entity to be retrieved from a server.
 * Typically 1:1 with a url endpoint.
 */


var Resource = /*#__PURE__*/function (_SimpleResource) {
  _inheritsLoose(Resource, _SimpleResource);

  function Resource() {
    return _SimpleResource.apply(this, arguments) || this;
  }

  /** A function to mutate all request options for fetch */

  /** Init options for fetch - run at fetch */
  Resource.getFetchInit = function getFetchInit(init) {
    if (this.fetchOptionsPlugin) return this.fetchOptionsPlugin(init);
    return init;
  }
  /** Perform network request and resolve with HTTP Response */
  ;

  Resource.fetchResponse = function fetchResponse(method, url, body) {
    var options = {
      method: method.toUpperCase()
    };
    options = this.getFetchInit(options);
    if (body && isPojo(body)) options.body = JSON.stringify(body);

    if (!options.body || typeof options.body === 'string') {
      options.headers = Object.assign({
        'Content-Type': 'application/json'
      }, options.headers);
    }

    return fetch(url, options).then(function (response) {
      if (!response.ok) {
        throw new NetworkError(response);
      }

      return response;
    }).catch(function (error) {
      // ensure CORS, network down, and parse errors are still caught by NetworkErrorBoundary
      if (error instanceof TypeError) {
        error.status = 400;
      }

      throw error;
    });
  }
  /** Perform network request and resolve with json body */
  ;

  Resource.fetch = function fetch(method, url, body) {
    return this.fetchResponse(method, url, body).then(function (response) {
      var _response$headers$get;

      if (!((_response$headers$get = response.headers.get('content-type')) !== null && _response$headers$get !== void 0 && _response$headers$get.includes('json')) || response.status === 204) return response.text();
      return response.json().catch(function (error) {
        error.status = 400;
        throw error;
      });
    });
  };

  return Resource;
}(SimpleResource);

Resource.fetchOptionsPlugin = void 0;
var proto = Object.prototype;
var gpo = Object.getPrototypeOf;

function isPojo(obj) {
  if (obj === null || typeof obj !== 'object') {
    return false;
  }

  return gpo(obj) === proto;
}

var REACT_ELEMENT_TYPE;
function _createRawReactElement(type, props, key, children) {
  if (!REACT_ELEMENT_TYPE) {
    REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol["for"] && Symbol["for"]("react.element") || 0xeac7;
  }

  var defaultProps = type && type.defaultProps;
  var childrenLength = arguments.length - 3;

  if (!props && childrenLength !== 0) {
    props = {
      children: void 0
    };
  }

  if (childrenLength === 1) {
    props.children = children;
  } else if (childrenLength > 1) {
    var childArray = new Array(childrenLength);

    for (var i = 0; i < childrenLength; i++) {
      childArray[i] = arguments[i + 3];
    }

    props.children = childArray;
  }

  if (props && defaultProps) {
    for (var propName in defaultProps) {
      if (props[propName] === void 0) {
        props[propName] = defaultProps[propName];
      }
    }
  } else if (!props) {
    props = defaultProps || {};
  }

  return {
    $$typeof: REACT_ELEMENT_TYPE,
    type: type,
    key: key === undefined ? null : '' + key,
    ref: null,
    props: props,
    _owner: null
  };
}

function isNetworkError(error) {
  return Object.prototype.hasOwnProperty.call(error, 'status');
}

var NetworkErrorBoundary = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(NetworkErrorBoundary, _React$Component);

  function NetworkErrorBoundary() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    _this.state = {};
    return _this;
  }

  NetworkErrorBoundary.getDerivedStateFromError = function getDerivedStateFromError(error) {
    if (isNetworkError(error)) {
      return {
        error: error
      };
    }
  };

  var _proto = NetworkErrorBoundary.prototype;

  _proto.render = function render() {
    if (!this.state.error) {
      return this.props.children;
    }

    return /*#__PURE__*/_createRawReactElement(this.props.fallbackComponent, {
      error: this.state.error
    });
  };

  return NetworkErrorBoundary;
}(React__default['default'].Component);

NetworkErrorBoundary.defaultProps = {
  fallbackComponent: function fallbackComponent(_ref) {
    var error = _ref.error;
    return /*#__PURE__*/_createRawReactElement("div", {}, void 0, error.status, " ", error.response && error.response.statusText);
  }
};

var BrowserConnectionListener = /*#__PURE__*/function () {
  function BrowserConnectionListener() {}

  var _proto = BrowserConnectionListener.prototype;

  _proto.isOnline = function isOnline() {
    if (navigator.onLine !== undefined) {
      return navigator.onLine;
    }

    return true;
  };

  _proto.addOnlineListener = function addOnlineListener(handler) {
    addEventListener('online', handler);
  };

  _proto.removeOnlineListener = function removeOnlineListener(handler) {
    removeEventListener('online', handler);
  };

  _proto.addOfflineListener = function addOfflineListener(handler) {
    addEventListener('offline', handler);
  };

  _proto.removeOfflineListener = function removeOfflineListener(handler) {
    removeEventListener('offline', handler);
  };

  return BrowserConnectionListener;
}();
var AlwaysOnlineConnectionListener = /*#__PURE__*/function () {
  function AlwaysOnlineConnectionListener() {}

  var _proto2 = AlwaysOnlineConnectionListener.prototype;

  _proto2.isOnline = function isOnline() {
    /* istanbul ignore next */
    return true;
  };

  _proto2.addOnlineListener = function addOnlineListener() {};

  _proto2.removeOnlineListener = function removeOnlineListener() {};

  _proto2.addOfflineListener = function addOfflineListener() {};

  _proto2.removeOfflineListener = function removeOfflineListener() {};

  return AlwaysOnlineConnectionListener;
}();
var DefaultConnectionListener;
/* istanbul ignore if */

if (typeof navigator !== 'undefined' && typeof addEventListener === 'function') {
  DefaultConnectionListener = BrowserConnectionListener;
} else {
  /* istanbul ignore next */
  DefaultConnectionListener = AlwaysOnlineConnectionListener;
}

var DefaultConnectionListener$1 = DefaultConnectionListener;

var FETCH_TYPE = core.actionTypes.FETCH_TYPE;
/**
 * PollingSubscription keeps a given resource updated by
 * dispatching a fetch at a rate equal to the minimum update
 * interval requested.
 */

var PollingSubscription = /*#__PURE__*/function () {
  function PollingSubscription(_ref, dispatch, connectionListener) {
    var _this = this;

    var key = _ref.key,
        schema = _ref.schema,
        fetch = _ref.fetch,
        frequency = _ref.frequency,
        getState = _ref.getState;
    this.frequencyHistogram = new Map();

    this.offlineListener = function () {
      // this clears existing listeners, so no need to clear offline listener
      _this.cleanup();

      _this.connectionListener.addOnlineListener(_this.onlineListener);
    };

    this.onlineListener = function () {
      _this.connectionListener.removeOnlineListener(_this.onlineListener);

      var now = Date.now();
      _this.startId = setTimeout(function () {
        delete _this.startId;

        _this.update();

        _this.run();
      }, Math.max(0, _this.lastFetchTime() - now + _this.frequency));

      _this.connectionListener.addOfflineListener(_this.offlineListener);
    };

    if (frequency === undefined) throw new Error('frequency needed for polling subscription');
    this.schema = schema;
    this.fetch = fetch;
    this.frequency = frequency;
    this.key = key;
    this.frequencyHistogram.set(this.frequency, 1);
    this.dispatch = dispatch;
    this.getState = getState;
    this.connectionListener = connectionListener || new DefaultConnectionListener$1(); // Kickstart running since this is initialized after the online notif is sent

    if (this.connectionListener.isOnline()) {
      this.onlineListener();
    } else {
      this.offlineListener();
    }
  }
  /** Subscribe to a frequency */


  var _proto = PollingSubscription.prototype;

  _proto.add = function add(frequency) {
    if (frequency === undefined) return;

    if (this.frequencyHistogram.has(frequency)) {
      this.frequencyHistogram.set(frequency, this.frequencyHistogram.get(frequency) + 1);
    } else {
      this.frequencyHistogram.set(frequency, 1); // new min so restart service

      if (frequency < this.frequency) {
        this.frequency = frequency;
        this.run();
      }
    }
  }
  /** Unsubscribe from a frequency */
  ;

  _proto.remove = function remove(frequency) {
    if (frequency === undefined) return false;

    if (this.frequencyHistogram.has(frequency)) {
      this.frequencyHistogram.set(frequency, this.frequencyHistogram.get(frequency) - 1);

      if (this.frequencyHistogram.get(frequency) < 1) {
        this.frequencyHistogram.delete(frequency); // nothing subscribed to this anymore...it is invalid

        if (this.frequencyHistogram.size === 0) {
          this.cleanup();
          return true;
        } // this was the min, so find the next size


        if (frequency <= this.frequency) {
          this.frequency = Math.min.apply(Math, this.frequencyHistogram.keys());
          this.run();
        }
      }
    }
    /* istanbul ignore next */
    else if (process.env.NODE_ENV !== 'production') {
        console.error("Mismatched remove: " + frequency + " is not subscribed for " + this.key);
      }

    return false;
  }
  /** Cleanup means clearing out background interval. */
  ;

  _proto.cleanup = function cleanup() {
    if (this.intervalId) {
      clearInterval(this.intervalId);
      this.intervalId = undefined;
    }

    if (this.lastIntervalId) {
      clearInterval(this.lastIntervalId);
      this.lastIntervalId = undefined;
    }

    if (this.startId) {
      clearTimeout(this.startId);
      delete this.startId;
    }

    this.connectionListener.removeOnlineListener(this.onlineListener);
    this.connectionListener.removeOfflineListener(this.offlineListener);
  }
  /** Trigger request for latest resource */
  ;

  _proto.update = function update() {
    this.dispatch({
      type: FETCH_TYPE,
      payload: this.fetch,
      meta: {
        schema: this.schema,
        key: this.key,
        type: 'read',
        throttle: true,
        options: {
          dataExpiryLength: this.frequency / 2,
          errorExpiryLength: this.frequency / 10
        },
        resolve: function resolve() {},
        reject: function reject() {}
      }
    });
  }
  /** What happens when browser goes offline */
  ;

  /** Run polling process with current frequency
   *
   * Will clean up old poll interval on next run
   */
  _proto.run = function run() {
    var _this2 = this;

    if (this.startId) return;
    this.lastIntervalId = this.intervalId;
    this.intervalId = setInterval(function () {
      // since we don't know how long into the last poll it was before resetting
      // we wait til the next fetch to clear old intervals
      if (_this2.lastIntervalId) {
        clearInterval(_this2.lastIntervalId);
        _this2.lastIntervalId = undefined;
      }

      _this2.update();
    }, this.frequency);
  }
  /** Last fetch time */
  ;

  _proto.lastFetchTime = function lastFetchTime() {
    var _this$getState$meta$t, _this$getState$meta$t2;

    return (_this$getState$meta$t = (_this$getState$meta$t2 = this.getState().meta[this.key]) === null || _this$getState$meta$t2 === void 0 ? void 0 : _this$getState$meta$t2.date) != null ? _this$getState$meta$t : 0;
  };

  return PollingSubscription;
}();

var SUBSCRIBE_TYPE = core.actionTypes.SUBSCRIBE_TYPE,
    UNSUBSCRIBE_TYPE = core.actionTypes.UNSUBSCRIBE_TYPE;

/** Handles subscription actions -> fetch or receive actions
 *
 * Constructor takes a SubscriptionConstructable class to control how
 * subscriptions are handled. (e.g., polling, websockets)
 */
var SubscriptionManager = /*#__PURE__*/function () {
  function SubscriptionManager(Subscription) {
    var _this = this;

    this.subscriptions = {};
    this.Subscription = Subscription;

    this.middleware = function (_ref) {
      var dispatch = _ref.dispatch,
          getState = _ref.getState;
      return function (next) {
        return function (action) {
          switch (action.type) {
            case SUBSCRIBE_TYPE:
              try {
                _this.handleSubscribe(action, dispatch, getState);
              } catch (e) {
                console.error(e);
              }

              return Promise.resolve();

            case UNSUBSCRIBE_TYPE:
              _this.handleUnsubscribe(action, dispatch);

              return Promise.resolve();

            default:
              return next(action);
          }
        };
      };
    };
  }
  /** Ensures all subscriptions are cleaned up. */


  var _proto = SubscriptionManager.prototype;

  _proto.cleanup = function cleanup() {
    for (var _key in this.subscriptions) {
      this.subscriptions[_key].cleanup();
    }
  }
  /** Called when middleware intercepts 'rest-hooks/subscribe' action.
   *
   */
  ;

  _proto.handleSubscribe = function handleSubscribe(action, dispatch, getState) {
    var _action$meta$options;

    var key = action.meta.key;
    var frequency = (_action$meta$options = action.meta.options) === null || _action$meta$options === void 0 ? void 0 : _action$meta$options.pollFrequency;

    if (key in this.subscriptions) {
      this.subscriptions[key].add(frequency);
    } else {
      this.subscriptions[key] = new this.Subscription({
        schema: action.meta.schema,
        fetch: action.meta.fetch,
        frequency: frequency,
        key: key,
        getState: getState
      }, dispatch);
    }
  }
  /** Called when middleware intercepts 'rest-hooks/unsubscribe' action.
   *
   */
  ;

  _proto.handleUnsubscribe = function handleUnsubscribe(action, dispatch) {
    var _action$meta$options2;

    var key = action.meta.key;
    var frequency = (_action$meta$options2 = action.meta.options) === null || _action$meta$options2 === void 0 ? void 0 : _action$meta$options2.pollFrequency;
    /* istanbul ignore else */

    if (key in this.subscriptions) {
      var empty = this.subscriptions[key].remove(frequency);

      if (empty) {
        delete this.subscriptions[key];
      }
    } else if (process.env.NODE_ENV !== 'production') {
      console.error("Mismatched unsubscribe: " + key + " is not subscribed");
    }
  }
  /** Attaches Manager to store
   *
   * Intercepts 'rest-hooks/subscribe'/'rest-hooks/unsubscribe' to register resources that
   * need to be kept up to date.
   *
   * Will possibly dispatch 'rest-hooks/fetch' or 'rest-hooks/receive' to keep resources fresh
   *
   */
  ;

  _proto.getMiddleware = function getMiddleware() {
    return this.middleware;
  };

  return SubscriptionManager;
}();

/** Integrates with https://github.com/zalmoxisus/redux-devtools-extension
 *
 * Options: https://github.com/zalmoxisus/redux-devtools-extension/blob/master/docs/API/Arguments.md
 */
var DevToolsManager = /*#__PURE__*/function () {
  function DevToolsManager(config) {
    var _this = this;

    if (config === void 0) {
      var _globalThis$document;

      config = {
        name: "Rest Hooks: " + ((_globalThis$document = globalThis.document) === null || _globalThis$document === void 0 ? void 0 : _globalThis$document.title)
      };
    }

    /* istanbul ignore next */
    this.devTools = typeof window !== 'undefined' && window.__REDUX_DEVTOOLS_EXTENSION__ && window.__REDUX_DEVTOOLS_EXTENSION__.connect(config);
    /* istanbul ignore if */

    /* istanbul ignore next */

    if (process.env.NODE_ENV === 'development' && this.devTools) {
      this.middleware = function (_ref) {
        var getState = _ref.getState;
        return function (next) {
          return function (action) {
            return next(action).then(function () {
              var state = getState();

              _this.devTools.send(action, state.optimistic.reduce(core.reducer, state), undefined, 'REST_HOOKS');
            });
          };
        };
      };
    } else {
      this.middleware = function () {
        return function (next) {
          return function (action) {
            return next(action);
          };
        };
      };
    }
  }
  /** Called when initial state is ready */


  var _proto = DevToolsManager.prototype;

  _proto.init = function init(state) {
    if (this.devTools) this.devTools.init(state);
  }
  /** Ensures all subscriptions are cleaned up. */
  ;

  _proto.cleanup = function cleanup() {}
  /** Attaches Manager to store
   *
   */
  ;

  _proto.getMiddleware = function getMiddleware() {
    return this.middleware;
  };

  return DevToolsManager;
}();

var PromiseifyMiddleware = function PromiseifyMiddleware(_) {
  return function (next) {
    return function (action) {
      next(action);
      return Promise.resolve();
    };
  };
};

function ExternalCacheProvider(_ref) {
  var children = _ref.children,
      store = _ref.store,
      selector = _ref.selector;

  var _useState = React.useState(function () {
    return selector(store.getState());
  }),
      state = _useState[0],
      setState = _useState[1];

  var optimisticState = React.useMemo(function () {
    return state.optimistic.reduce(core.reducer, state);
  }, [state]);
  React.useEffect(function () {
    var unsubscribe = store.subscribe(function () {
      setState(selector(store.getState()));
    });
    return unsubscribe; // we don't care to recompute if they change selector - only when store updates
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [store]);
  var dispatch = core.usePromisifiedDispatch(store.dispatch, state);
  return /*#__PURE__*/_createRawReactElement(core.DispatchContext.Provider, {
    value: dispatch
  }, void 0, /*#__PURE__*/_createRawReactElement(core.StateContext.Provider, {
    value: optimisticState
  }, void 0, children));
}

var mapMiddleware = function mapMiddleware(selector) {
  return function () {
    for (var _len = arguments.length, middlewares = new Array(_len), _key = 0; _key < _len; _key++) {
      middlewares[_key] = arguments[_key];
    }

    return middlewares.map(function (middleware) {
      return function (_ref) {
        var getState = _ref.getState,
            dispatch = _ref.dispatch;

        var wrapped = function wrapped() {
          return selector(getState());
        };

        return middleware({
          getState: wrapped,
          dispatch: dispatch
        });
      };
    });
  };
};

var CacheProvider = function CacheProvider(props) {
  return core.CacheProvider(props);
};

CacheProvider.defaultProps = Object.assign({}, core.CacheProvider.defaultProps, {
  managers: [].concat(core.CacheProvider.defaultProps.managers, [new SubscriptionManager(PollingSubscription)])
});
/* istanbul ignore next */

if (process.env.NODE_ENV !== 'production') CacheProvider.defaultProps.managers.unshift(new DevToolsManager());

/** Use selector to access part of state */

function useSelectionUnstable(select, params, paramSerializer) {
  if (paramSerializer === void 0) {
    paramSerializer = function paramSerializer(p) {
      return JSON.stringify(p);
    };
  }

  var state = React.useContext(core.StateContext); // TODO: if this is identical to before and render was triggered by state update,
  // we should short-circuit entire rest of render
  // params must be serialized in check
  // eslint-disable-next-line react-hooks/exhaustive-deps

  var selection = React.useMemo(function () {
    return params && select(state, params);
  }, [// eslint-disable-next-line react-hooks/exhaustive-deps
  params && paramSerializer(params), select, state]);
  return selection;
}

var buildInferredResults = core.__INTERNAL__.buildInferredResults;
var RIC = core.__INTERNAL__.RIC;

var internal = /*#__PURE__*/Object.freeze({
  __proto__: null,
  buildInferredResults: buildInferredResults,
  RIC: RIC,
  initialState: core.initialState,
  StateContext: core.StateContext,
  DispatchContext: core.DispatchContext,
  hasUsableData: core.hasUsableData
});

Object.defineProperty(exports, 'Endpoint', {
  enumerable: true,
  get: function () {
    return core.Endpoint;
  }
});
Object.defineProperty(exports, 'Entity', {
  enumerable: true,
  get: function () {
    return core.FlatEntity;
  }
});
Object.defineProperty(exports, 'Index', {
  enumerable: true,
  get: function () {
    return core.Index;
  }
});
Object.defineProperty(exports, 'NestedEntity', {
  enumerable: true,
  get: function () {
    return core.Entity;
  }
});
Object.defineProperty(exports, 'SimpleRecord', {
  enumerable: true,
  get: function () {
    return core.SimpleRecord;
  }
});
Object.defineProperty(exports, 'isEntity', {
  enumerable: true,
  get: function () {
    return core.isEntity;
  }
});
Object.defineProperty(exports, 'schemas', {
  enumerable: true,
  get: function () {
    return core.schema;
  }
});
Object.defineProperty(exports, 'useCache', {
  enumerable: true,
  get: function () {
    return core.useCache;
  }
});
Object.defineProperty(exports, 'useDenormalized', {
  enumerable: true,
  get: function () {
    return core.useDenormalized;
  }
});
Object.defineProperty(exports, 'useError', {
  enumerable: true,
  get: function () {
    return core.useError;
  }
});
Object.defineProperty(exports, 'useFetcher', {
  enumerable: true,
  get: function () {
    return core.useFetcher;
  }
});
Object.defineProperty(exports, 'useInvalidator', {
  enumerable: true,
  get: function () {
    return core.useInvalidator;
  }
});
Object.defineProperty(exports, 'useMeta', {
  enumerable: true,
  get: function () {
    return core.useMeta;
  }
});
Object.defineProperty(exports, 'usePromisifiedDispatch', {
  enumerable: true,
  get: function () {
    return core.usePromisifiedDispatch;
  }
});
Object.defineProperty(exports, 'useResetter', {
  enumerable: true,
  get: function () {
    return core.useResetter;
  }
});
Object.defineProperty(exports, 'useResource', {
  enumerable: true,
  get: function () {
    return core.useResource;
  }
});
Object.defineProperty(exports, 'useRetrieve', {
  enumerable: true,
  get: function () {
    return core.useRetrieve;
  }
});
Object.defineProperty(exports, 'useSubscription', {
  enumerable: true,
  get: function () {
    return core.useSubscription;
  }
});
exports.CacheProvider = CacheProvider;
exports.DefaultConnectionListener = DefaultConnectionListener$1;
exports.DevToolsManager = DevToolsManager;
exports.ExternalCacheProvider = ExternalCacheProvider;
exports.NetworkErrorBoundary = NetworkErrorBoundary;
exports.PollingSubscription = PollingSubscription;
exports.PromiseifyMiddleware = PromiseifyMiddleware;
exports.Resource = Resource;
exports.SimpleResource = SimpleResource;
exports.SubscriptionManager = SubscriptionManager;
exports.__INTERNAL__ = internal;
exports.mapMiddleware = mapMiddleware;
exports.useSelectionUnstable = useSelectionUnstable;
